<?php

namespace app\controllers\mikrotik\capsman;

use yii\helpers\Url;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use app\models\mikrotik\MikrotikSideMenu;
use yii\data\ArrayDataProvider;
use app\models\mikrotik\capsman\Interfaces;

class InterfacesController extends Controller {

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'except' => ['index'],
                'rules' => [
                   [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanCreateInterfaces'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanDeleteInterfaces'],
                    ],
                    [
                        'actions' => ['disable'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanDisableInterfaces'],
                    ],
                    [
                        'actions' => ['enable'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanEnableInterfaces'],
                    ], [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanUpdateInterfaces'],
                    ],

                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['admin'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    public function actionIndex() {
        $model = new Interfaces();
        return var_dump($model->getAll());
    }

    public function actionUpdate() {
        $id = Yii::$app->request->get('id');
        $menu = new MikrotikSideMenu();
        $model = new Interfaces();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($_POST['Interfaces']['configurationrx_chains'] != '') {
                $opt = implode(",", $_POST['Interfaces']['configurationrx_chains']);
                $model->configurationrx_chains = $opt;
            }
            if ($_POST['Interfaces']['configurationtx_chains'] != '') {
                $opt = implode(",", $_POST['Interfaces']['configurationtx_chains']);
                $model->configurationtx_chains = $opt;
            }
            if ($_POST['Interfaces']['securityauthentication_types'] != '') {
                $opt = implode(",", $_POST['Interfaces']['securityauthentication_types']);
                $model->securityauthentication_types = $opt;
            }
            if ($_POST['Interfaces']['securityencryption'] != '') {
                $opt = implode(",", $_POST['Interfaces']['securityencryption']);
                $model->securityencryption = $opt;
            }

            if ($_POST['Interfaces']['securityeap_methods'] != '') {
                $opt = implode(",", $_POST['Interfaces']['securityeap_methods']);
                $model->securityeap_methods = $opt;
            }
            $c = $model->update($id);
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
            }
        } else {
            $model->get($id);
        }

        $model->configurationrx_chains = explode(',', $model->configurationrx_chains);
        $model->configurationtx_chains = explode(',', $model->configurationtx_chains);
        $model->securityauthentication_types = explode(',', $model->securityauthentication_types);
        $model->securityencryption = explode(',', $model->securityencryption);
        $model->securityeap_methods = explode(',', $model->securityeap_methods);
        return $this->render('/mikrotik/capsman/interfaces', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'update',
                    'channel' => $model->getChannel(),
                    'datapath' => $model->getDatapath(),
                    'bridge' => $model->getBridge(),
                    'security' => $model->getSecurity(),
                    'cert' => $model->getCert(),
                    'master' => $model->getMaster(),
                    'config' => $model->getConf(),
        ]);
    }

    public function actionCreate() {
        $menu = new MikrotikSideMenu();
        $model = new Interfaces();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($_POST['Interfaces']['configurationrx_chains'] != '') {
                $opt = implode(",", $_POST['Interfaces']['configurationrx_chains']);
                $model->configurationrx_chains = $opt;
            }
            if ($_POST['Interfaces']['configurationtx_chains'] != '') {
                $opt = implode(",", $_POST['Interfaces']['configurationtx_chains']);
                $model->configurationtx_chains = $opt;
            }
            if ($_POST['Interfaces']['securityauthentication_types'] != '') {
                $opt = implode(",", $_POST['Interfaces']['securityauthentication_types']);
                $model->securityauthentication_types = $opt;
            }
            if ($_POST['Interfaces']['securityencryption'] != '') {
                $opt = implode(",", $_POST['Interfaces']['securityencryption']);
                $model->securityencryption = $opt;
            }

            if ($_POST['Interfaces']['securityeap_methods'] != '') {
                $opt = implode(",", $_POST['Interfaces']['securityeap_methods']);
                $model->securityeap_methods = $opt;
            }
            $c = $model->create();
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
            }
        }

        return $this->render('/mikrotik/capsman/interfaces', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'create',
                    'channel' => $model->getChannel(),
                    'datapath' => $model->getDatapath(),
                    'bridge' => $model->getBridge(),
                    'security' => $model->getSecurity(),
                    'cert' => $model->getCert(),
                    'master' => $model->getMaster(),
                    'config' => $model->getConf(),
        ]);
    }

    public function actionDisable() {
        $id = Yii::$app->request->get('id');
        $model = new Interfaces();
        $model->disable($id);
        return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
    }

    public function actionDelete() {
        $id = Yii::$app->request->get('id');
        $model = new Interfaces();
        $model->delete($id);
        return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
    }

    public function actionEnable() {
        $id = Yii::$app->request->get('id');
        $model = new Interfaces();
        $model->enable($id);
        return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
    }

   

}
